/****************************************************************************
*  Copyright (c) 2011 by Michael Fischer. All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*  
*  1. Redistributions of source code must retain the above copyright 
*     notice, this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the 
*     documentation and/or other materials provided with the distribution.
*  3. Neither the name of the author nor the names of its contributors may 
*     be used to endorse or promote products derived from this software 
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
*  SUCH DAMAGE.
*
****************************************************************************
*  History:
*
*  28.04.2011  mifi  First Version for the TWR-K40X256
****************************************************************************/
#define __VECTORS_K40_C__

/*=========================================================================*/
/*  DEFINE: All extern Data                                                */
/*=========================================================================*/
extern unsigned long _estack;

/*
 * Flash Configuration Field Description
 */ 

#define FCFD1  ((void*)0xffffffff)
#define FCFD2  ((void*)0xffffffff)
#define FCFD3  ((void*)0xffffffff)
#define FCFD4  ((void*)0xfffffffe)

/*=========================================================================*/
/*  DEFINE: Prototypes                                                     */
/*=========================================================================*/
void ResetHandler(void);

void NMI_Handler (void) __attribute__((weak));
void HardFault_Handler (void) __attribute__((weak));
void MemManage_Handler (void) __attribute__((weak));
void BusFault_Handler (void) __attribute__((weak));
void UsageFault_Handler (void) __attribute__((weak));
void SVC_Handler (void) __attribute__((weak));
void DebugMon_Handler (void) __attribute__((weak));
void PendSV_Handler (void) __attribute__((weak));
void SysTick_Handler (void) __attribute__((weak));

void DMA0_IRQHandler (void) __attribute__((weak));
void DMA1_IRQHandler (void) __attribute__((weak));
void DMA2_IRQHandler (void) __attribute__((weak));
void DMA3_IRQHandler (void) __attribute__((weak));
void DMA4_IRQHandler (void) __attribute__((weak));
void DMA5_IRQHandler (void) __attribute__((weak));
void DMA6_IRQHandler (void) __attribute__((weak));
void DMA7_IRQHandler (void) __attribute__((weak));
void DMA8_IRQHandler (void) __attribute__((weak));
void DMA9_IRQHandler (void) __attribute__((weak));
void DMA10_IRQHandler (void) __attribute__((weak));
void DMA11_IRQHandler (void) __attribute__((weak));
void DMA12_IRQHandler (void) __attribute__((weak));
void DMA13_IRQHandler (void) __attribute__((weak));
void DMA14_IRQHandler (void) __attribute__((weak));
void DMA15_IRQHandler (void) __attribute__((weak));
void DMA_Error_IRQHandler (void) __attribute__((weak));
void MCM_IRQHandler (void) __attribute__((weak));
void FTFL_IRQHandler (void) __attribute__((weak));
void Read_Collision_IRQHandler (void) __attribute__((weak));
void LVD_LVW_IRQHandler (void) __attribute__((weak));
void LLW_IRQHandler (void) __attribute__((weak));
void Watchdog_IRQHandler (void) __attribute__((weak));
void I2C0_IRQHandler (void) __attribute__((weak));
void I2C1_IRQHandler (void) __attribute__((weak));
void SPI0_IRQHandler (void) __attribute__((weak));
void SPI1_IRQHandler (void) __attribute__((weak));
void SPI2_IRQHandler (void) __attribute__((weak));
void CAN0_ORed_Message_buffer_IRQHandler (void) __attribute__((weak));
void CAN0_Bus_Off_IRQHandler (void) __attribute__((weak));
void CAN0_Error_IRQHandler (void) __attribute__((weak));
void CAN0_Tx_Warning_IRQHandler (void) __attribute__((weak));
void CAN0_Rx_Warning_IRQHandler (void) __attribute__((weak));
void CAN0_Wake_Up_IRQHandler (void) __attribute__((weak));
void CAN1_ORed_Message_buffer_IRQHandler (void) __attribute__((weak));
void CAN1_Bus_Off_IRQHandler (void) __attribute__((weak));
void CAN1_Error_IRQHandler (void) __attribute__((weak));
void CAN1_Tx_Warning_IRQHandler (void) __attribute__((weak));
void CAN1_Rx_Warning_IRQHandler (void) __attribute__((weak));
void CAN1_Wake_Up_IRQHandler (void) __attribute__((weak));
void UART0_RX_TX_IRQHandler (void) __attribute__((weak));
void UART0_ERR_IRQHandler (void) __attribute__((weak));
void UART1_RX_TX_IRQHandler (void) __attribute__((weak));
void UART1_ERR_IRQHandler (void) __attribute__((weak));
void UART2_RX_TX_IRQHandler (void) __attribute__((weak));
void UART2_ERR_IRQHandler (void) __attribute__((weak));
void UART3_RX_TX_IRQHandler (void) __attribute__((weak));
void UART3_ERR_IRQHandler (void) __attribute__((weak));
void UART4_RX_TX_IRQHandler (void) __attribute__((weak));
void UART4_ERR_IRQHandler (void) __attribute__((weak));
void UART5_RX_TX_IRQHandler (void) __attribute__((weak));
void UART5_ERR_IRQHandler (void) __attribute__((weak));
void ADC0_IRQHandler (void) __attribute__((weak));
void ADC1_IRQHandler (void) __attribute__((weak));
void CMP0_IRQHandler (void) __attribute__((weak));
void CMP1_IRQHandler (void) __attribute__((weak));
void CMP2_IRQHandler (void) __attribute__((weak));
void FTM0_IRQHandler (void) __attribute__((weak));
void FTM1_IRQHandler (void) __attribute__((weak));
void FTM2_IRQHandler (void) __attribute__((weak));
void CMT_IRQHandler (void) __attribute__((weak));
void RTC_IRQHandler (void) __attribute__((weak));
void PIT0_IRQHandler (void) __attribute__((weak));
void PIT1_IRQHandler (void) __attribute__((weak));
void PIT2_IRQHandler (void) __attribute__((weak));
void PIT3_IRQHandler (void) __attribute__((weak));
void PDB0_IRQHandler (void) __attribute__((weak));
void USB0_IRQHandler (void) __attribute__((weak));
void USBDCD_IRQHandler (void) __attribute__((weak));
void I2S0_IRQHandler (void) __attribute__((weak));
void SDHC_IRQHandler (void) __attribute__((weak));
void DAC0_IRQHandler (void) __attribute__((weak));
void DAC1_IRQHandler (void) __attribute__((weak));
void TSI0_IRQHandler (void) __attribute__((weak));
void MCG_IRQHandler (void) __attribute__((weak));
void LPTimer_IRQHandler (void) __attribute__((weak));
void LCD_IRQHandler (void) __attribute__((weak));
void PORTA_IRQHandler (void) __attribute__((weak));
void PORTB_IRQHandler (void) __attribute__((weak));
void PORTC_IRQHandler (void) __attribute__((weak));
void PORTD_IRQHandler (void) __attribute__((weak));
void PORTE_IRQHandler (void) __attribute__((weak));
void Software_IRQHandler (void) __attribute__((weak));
void Reserved_IRQHandler (void) __attribute__((weak));

/*=========================================================================*/
/*  DEFINE: All code exported                                              */
/*=========================================================================*/
/*
 * This is our vector table.
 * Take a look in the K40 Sub-Family Reference manual
 * (K40P144M100SF2RM.pdf) for more information.
 * For the vector table I have used Rev. 4, 1 Mar 2011
 * of the document.
 */
__attribute__ ((section(".vectors"), used))
void (* const gVectors[])(void) = 
{
   (void (*)(void))((unsigned long)&_estack),
   ResetHandler,
   NMI_Handler,
   HardFault_Handler,
   MemManage_Handler,
   BusFault_Handler,
   UsageFault_Handler,
   0, 0, 0, 0,
   SVC_Handler,
   DebugMon_Handler,
   0,
   PendSV_Handler,
   SysTick_Handler,
   
   DMA0_IRQHandler,
   DMA1_IRQHandler,
   DMA2_IRQHandler,
   DMA3_IRQHandler,
   DMA4_IRQHandler,
   DMA5_IRQHandler,
   DMA6_IRQHandler,
   DMA7_IRQHandler,
   DMA8_IRQHandler,
   DMA9_IRQHandler,
   DMA10_IRQHandler,
   DMA11_IRQHandler,
   DMA12_IRQHandler,
   DMA13_IRQHandler,
   DMA14_IRQHandler,
   DMA15_IRQHandler,
   DMA_Error_IRQHandler,
   MCM_IRQHandler,
   FTFL_IRQHandler,
   Read_Collision_IRQHandler,
   LVD_LVW_IRQHandler,
   LLW_IRQHandler,
   Watchdog_IRQHandler,
   Reserved_IRQHandler,
   I2C0_IRQHandler,
   I2C1_IRQHandler,
   SPI0_IRQHandler,
   SPI1_IRQHandler,
   SPI2_IRQHandler,
   CAN0_ORed_Message_buffer_IRQHandler,
   CAN0_Bus_Off_IRQHandler,
   CAN0_Error_IRQHandler,
   CAN0_Tx_Warning_IRQHandler,
   CAN0_Rx_Warning_IRQHandler,
   CAN0_Wake_Up_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   CAN1_ORed_Message_buffer_IRQHandler,
   CAN1_Bus_Off_IRQHandler,
   CAN1_Error_IRQHandler,
   CAN1_Tx_Warning_IRQHandler,
   CAN1_Rx_Warning_IRQHandler,
   CAN1_Wake_Up_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   UART0_RX_TX_IRQHandler,
   UART0_ERR_IRQHandler,
   UART1_RX_TX_IRQHandler,
   UART1_ERR_IRQHandler,
   UART2_RX_TX_IRQHandler,
   UART2_ERR_IRQHandler,
   UART3_RX_TX_IRQHandler,
   UART3_ERR_IRQHandler,
   UART4_RX_TX_IRQHandler,
   UART4_ERR_IRQHandler,
   UART5_RX_TX_IRQHandler,
   UART5_ERR_IRQHandler,
   ADC0_IRQHandler,
   ADC1_IRQHandler,
   CMP0_IRQHandler,
   CMP1_IRQHandler,
   CMP2_IRQHandler,
   FTM0_IRQHandler,
   FTM1_IRQHandler,
   FTM2_IRQHandler,
   CMT_IRQHandler,
   RTC_IRQHandler,
   Reserved_IRQHandler,
   PIT0_IRQHandler,
   PIT1_IRQHandler,
   PIT2_IRQHandler,
   PIT3_IRQHandler,
   PDB0_IRQHandler,
   USB0_IRQHandler,
   USBDCD_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   I2S0_IRQHandler,
   SDHC_IRQHandler,
   DAC0_IRQHandler,
   DAC1_IRQHandler,
   TSI0_IRQHandler,
   MCG_IRQHandler,
   LPTimer_IRQHandler,
   LCD_IRQHandler,
   PORTA_IRQHandler,
   PORTB_IRQHandler,
   PORTC_IRQHandler,
   PORTD_IRQHandler,
   PORTE_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Software_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   Reserved_IRQHandler,
   
   /* 
    * Here starts the: 
    * "Flash Configuration Field Description"
    */
   FCFD1,    
   FCFD2,
   FCFD3,
   FCFD4
}; /* gVectors */

/*
 * And here are the weak interrupt handlers.
 */
void NMI_Handler (void) { while(1); }
void HardFault_Handler (void) { while(1); }
void MemManage_Handler (void) { while(1); }
void BusFault_Handler (void) { while(1); }
void UsageFault_Handler (void) { while(1); }
void SVC_Handler (void) { while(1); }
void DebugMon_Handler (void) { while(1); }
void PendSV_Handler (void) { while(1); }
void SysTick_Handler (void) { while(1); }

void DMA0_IRQHandler (void) { while(1); }
void DMA1_IRQHandler (void) { while(1); }
void DMA2_IRQHandler (void) { while(1); }
void DMA3_IRQHandler (void) { while(1); }
void DMA4_IRQHandler (void) { while(1); }
void DMA5_IRQHandler (void) { while(1); }
void DMA6_IRQHandler (void) { while(1); }
void DMA7_IRQHandler (void) { while(1); }
void DMA8_IRQHandler (void) { while(1); }
void DMA9_IRQHandler (void) { while(1); }
void DMA10_IRQHandler (void) { while(1); }
void DMA11_IRQHandler (void) { while(1); }
void DMA12_IRQHandler (void) { while(1); }
void DMA13_IRQHandler (void) { while(1); }
void DMA14_IRQHandler (void) { while(1); }
void DMA15_IRQHandler (void) { while(1); }
void DMA_Error_IRQHandler (void) { while(1); }
void MCM_IRQHandler (void) { while(1); }
void FTFL_IRQHandler (void) { while(1); }
void Read_Collision_IRQHandler (void) { while(1); }
void LVD_LVW_IRQHandler (void) { while(1); }
void LLW_IRQHandler (void) { while(1); }
void Watchdog_IRQHandler (void) { while(1); }
void I2C0_IRQHandler (void) { while(1); }
void I2C1_IRQHandler (void) { while(1); }
void SPI0_IRQHandler (void) { while(1); }
void SPI1_IRQHandler (void) { while(1); }
void SPI2_IRQHandler (void) { while(1); }
void CAN0_ORed_Message_buffer_IRQHandler (void) { while(1); }
void CAN0_Bus_Off_IRQHandler (void) { while(1); }
void CAN0_Error_IRQHandler (void) { while(1); }
void CAN0_Tx_Warning_IRQHandler (void) { while(1); }
void CAN0_Rx_Warning_IRQHandler (void) { while(1); }
void CAN0_Wake_Up_IRQHandler (void) { while(1); }
void CAN1_ORed_Message_buffer_IRQHandler (void) { while(1); }
void CAN1_Bus_Off_IRQHandler (void) { while(1); }
void CAN1_Error_IRQHandler (void) { while(1); }
void CAN1_Tx_Warning_IRQHandler (void) { while(1); }
void CAN1_Rx_Warning_IRQHandler (void) { while(1); }
void CAN1_Wake_Up_IRQHandler (void) { while(1); }
void UART0_RX_TX_IRQHandler (void) { while(1); }
void UART0_ERR_IRQHandler (void) { while(1); }
void UART1_RX_TX_IRQHandler (void) { while(1); }
void UART1_ERR_IRQHandler (void) { while(1); }
void UART2_RX_TX_IRQHandler (void) { while(1); }
void UART2_ERR_IRQHandler (void) { while(1); }
void UART3_RX_TX_IRQHandler (void) { while(1); }
void UART3_ERR_IRQHandler (void) { while(1); }
void UART4_RX_TX_IRQHandler (void) { while(1); }
void UART4_ERR_IRQHandler (void) { while(1); }
void UART5_RX_TX_IRQHandler (void) { while(1); }
void UART5_ERR_IRQHandler (void) { while(1); }
void ADC0_IRQHandler (void) { while(1); }
void ADC1_IRQHandler (void) { while(1); }
void CMP0_IRQHandler (void) { while(1); }
void CMP1_IRQHandler (void) { while(1); }
void CMP2_IRQHandler (void) { while(1); }
void FTM0_IRQHandler (void) { while(1); }
void FTM1_IRQHandler (void) { while(1); }
void FTM2_IRQHandler (void) { while(1); }
void CMT_IRQHandler (void) { while(1); }
void RTC_IRQHandler (void) { while(1); }
void PIT0_IRQHandler (void) { while(1); }
void PIT1_IRQHandler (void) { while(1); }
void PIT2_IRQHandler (void) { while(1); }
void PIT3_IRQHandler (void) { while(1); }
void PDB0_IRQHandler (void) { while(1); }
void USB0_IRQHandler (void) { while(1); }
void USBDCD_IRQHandler (void) { while(1); }
void I2S0_IRQHandler (void) { while(1); }
void SDHC_IRQHandler (void) { while(1); }
void DAC0_IRQHandler (void) { while(1); }
void DAC1_IRQHandler (void) { while(1); }
void TSI0_IRQHandler (void) { while(1); }
void MCG_IRQHandler (void) { while(1); }
void LPTimer_IRQHandler (void) { while(1); }
void LCD_IRQHandler (void) { while(1); }
void PORTA_IRQHandler (void) { while(1); }
void PORTB_IRQHandler (void) { while(1); }
void PORTC_IRQHandler (void) { while(1); }
void PORTD_IRQHandler (void) { while(1); }
void PORTE_IRQHandler (void) { while(1); }
void Software_IRQHandler (void) { while(1); }
void Reserved_IRQHandler (void) { while(1); }

/*** EOF ***/
